<script setup lang="ts">
    import { GroupedStructuralExportJobDescription } from "./../../functions/export";
    import ExportStatusIndicator from "./ExportStatusIndicator.vue";

    const props = defineProps<{
        input: GroupedStructuralExportJobDescription;
        exportResults: {
            [key: string]: { timestamp: string; successfulJobs: number; totalPendingJobs: number; failure: boolean };
        };
        depth: number;
        childIndex: number;
        mainFirstCell: string;
    }>();
    const emit = defineEmits(["bubbleExportTrigger"]);

    function bubbleExportTrigger(key: string) {
        emit("bubbleExportTrigger", key);
    }

    function runGroup() {
        function aggregateKeys(input: GroupedStructuralExportJobDescription): string[] {
            let res: string[] = [];

            if (input.entry) {
                res.push(input.entry.key);
            }

            input.children.forEach((child) => {
                res.push(...aggregateKeys(child));
            });

            return res;
        }

        const keys = aggregateKeys(props.input);
        keys.forEach((key) => {
            bubbleExportTrigger(key);
        });
    }
</script>

<template>
    <tr v-if="props.input.pathSegment != ''">
        <td v-if="props.depth == 0 && props.childIndex == 0 && props.mainFirstCell != ''">{{ mainFirstCell }}</td>
        <td v-else>
            <template v-if="props.mainFirstCell == '' && props.input.entry">
                {{ props.input.entry.display }}
            </template>
        </td>
        <td>
            <b>
                <template v-for="_ in props.depth * 4"> &nbsp; </template>
                {{ input.pathSegment }}
            </b>
        </td>
        <td v-if="input.entry">
            {{ props.exportResults[input.entry.key] === undefined ? "" : props.exportResults[input.entry.key].successfulJobs }}
            /
            {{ props.exportResults[input.entry.key] === undefined ? "" : props.exportResults[input.entry.key].totalPendingJobs }}
        </td>
        <td v-else></td>
        <td v-if="input.entry">
            <export-status-indicator
                :state="
                    props.exportResults[input.entry.key] === undefined ||
                    (props.exportResults[input.entry.key].successfulJobs <
                        props.exportResults[input.entry.key].totalPendingJobs &&
                        !props.exportResults[input.entry.key].failure)
                        ? undefined
                        : !props.exportResults[input.entry.key].failure
                "
            />
        </td>
        <td v-else></td>
        <td v-if="input.entry">
            {{ props.exportResults[input.entry.key] === undefined ? "" : props.exportResults[input.entry.key].timestamp }}
        </td>
        <td v-else></td>
        <td>
            <v-btn
                @click="
                    () => {
                        if (input.entry) {
                            bubbleExportTrigger(input.entry.key);
                        } else {
                            runGroup();
                        }
                    }
                "
                size="small"
            >
                <template v-slot:prepend>
                    <span class="material-symbols-outlined"> {{ input.entry ? "export_notes" : "move_group" }} </span></template
                >
            </v-btn>
        </td>
    </tr>
    <export-row-recursive
        v-for="(child, i) in props.input.children"
        :depth="props.depth + 1"
        :export-results="props.exportResults"
        :input="child"
        :child-index="i"
        :main-first-cell="props.mainFirstCell"
        @bubble-export-trigger="(key) => bubbleExportTrigger(key)"
    ></export-row-recursive>
</template>
